"
 COPYRIGHT (c) 2016-2018 Jan Vrany
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libview/tests' }"

"{ NameSpace: Smalltalk }"

TestCase subclass:#SimpleViewTests
	instanceVariableNames:'view viewInteractor'
	classVariableNames:''
	poolDictionaries:''
	category:'Views-Basic-Tests'
!

!SimpleViewTests class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2016-2018 Jan Vrany
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!SimpleViewTests methodsFor:'running'!

setUp
    | window |

    Screen current isNil ifTrue:[ 
        Smalltalk openDisplay.
    ].
    self skipIf:Screen current isNil description:'No display connection'.
    Smalltalk loadPackage:'stx:goodies/sunit/ext/ui'.
    super setUp.

    "Add your own code here..."

    window := StandardSystemView new.
    window label: self printString.
    view := SimpleView origin:(0.0 @ 0.0) corner:(1.0 @ 1.0) in: window.
    view viewBackground: Color blue .  

    viewInteractor := view interactor.

    window open.
    window waitUntilVisible.

    "Modified: / 23-01-2019 / 16:00:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

tearDown
    view topView destroy.

    "Created: / 23-01-2019 / 15:08:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SimpleViewTests methodsFor:'tests'!

test_visibility_01
    | visibilityChanges |

    visibilityChanges := 0.

    view onChangeEvaluate:[:what | what == #visibility ifTrue:[ visibilityChanges := visibilityChanges + 1 ] ].  

    self assert: view shown.

    view beInvisible. 
    Delay waitForMilliseconds: 1000. "/ Give it time to show up.
    self assert: view shown not.
    self assert: visibilityChanges == 1.    

    view beVisible.
    Delay waitForMilliseconds: 1000. "/ Give it time unmap.
    self assert: view shown.
    self assert: visibilityChanges == 2.

    "Created: / 23-01-2019 / 15:08:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SimpleViewTests class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

